#include <WiFi.h>
#include <WiFiClientSecure.h>
#include <UniversalTelegramBot.h>
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27, 20, 4);
#include <Wire.h>
#include <PZEM004Tv30.h>
#define RXD2 16
#define TXD2 17
PZEM004Tv30 pzem(&Serial2);
#define relay 19
#define relay1 18

#define WIFI_SSID "WARKOP KHRISNA@WIFI.ID"
#define WIFI_PASSWORD "maju58"
#define BOT_TOKEN "5594184783:AAEYlOK4UxMdW5EQRCNPjK3uxvILE0X-J6o"
const unsigned long BOT_MTBS = 1000; // mean time between scan messages

WiFiClientSecure secured_client;
UniversalTelegramBot bot(BOT_TOKEN, secured_client);
unsigned long bot_lasttime;          // last time messages' scan has been done

void handleNewMessages(int numNewMessages)
{
  Serial.println("handleNewMessages");
  Serial.println(String(numNewMessages));

  for (int i = 0; i < numNewMessages; i++)
  {
    String chat_id = bot.messages[i].chat_id;
    String text = bot.messages[i].text;

    String from_name = bot.messages[i].from_name;
    if (from_name == "")
        from_name = "Guest";
    if (text == "/voltase")
    {
    float voltage = pzem.voltage();
    Serial.println("Mengirim pesan ke Telegram...");
    String reply;
    reply = (String)"Voltase saat ini\n" + 
            (String)"Voltase: " + voltage + (String)"V";
      bot.sendMessage(chat_id, reply);
    }
    if (text == "/arus")
    {
    float current = pzem.current();
    Serial.println("Mengirim pesan ke Telegram...");
    String reply;
    reply = (String)"Arus saat ini\n" + 
            (String)"Arus: " + current + (String)"A";
      bot.sendMessage(chat_id, reply);
    }
    if (text == "/energi")
    {
    float energy = pzem.energy();
    Serial.println("Mengirim pesan ke Telegram...");
    String reply;
    reply = (String)"Energi saat ini\n" + 
            (String)"Energi: " + energy + (String)"KWh" ;
      bot.sendMessage(chat_id, reply);
    }
    if (text == "/daya")
    {
    float power = pzem.power();
    Serial.println("Mengirim pesan ke Telegram...");
    String reply;
    reply = (String)"Daya saat ini\n" + 
            (String)"Daya: " + power + (String)"W" ;
      bot.sendMessage(chat_id, reply);
    }
    if (text == "/frekuensi")
    {
     float frequency = pzem.frequency();
    Serial.println("Mengirim pesan ke Telegram...");
    String reply;
    reply = (String)"Frekuensi saat ini\n" + 
            (String)"Frekuensi: " + frequency + (String)"Hz";
      bot.sendMessage(chat_id, reply);
    }
     if (text == "/pf")
    {
     float pf = pzem.pf();
    Serial.println("Mengirim pesan ke Telegram...");
    String reply;
    reply = (String)"Faktor daya saat ini\n" + 
            (String)"Faktor daya: " + pf;
      bot.sendMessage(chat_id, reply);
    }
    if (text == "/-pf")
    {
    Serial.println("Mengirim pesan ke Telegram...");
    String reply;
    reply = (String)"Perbaikan Faktor daya dimatikan";
      bot.sendMessage(chat_id, reply);
      digitalWrite(relay1,HIGH);
    }
    if (text == "/+pf")
    {
    Serial.println("Mengirim pesan ke Telegram...");
    String reply;
    reply = (String)"Perbaikan Faktor daya diaktifkan"; 
      bot.sendMessage(chat_id, reply);
      digitalWrite(relay1,LOW);
    }
    if (text == "/kondisi")
    {
      float voltage = pzem.voltage();
      float current = pzem.current();
      float energy = pzem.energy();
      float power = pzem.power();
      float frequency = pzem.frequency();
      float pf = pzem.pf();
      Serial.println("Mengirim pesan ke Telegram...");
    String reply;
    reply = (String)"Kondisi saat ini\n" + 
            (String)"Voltase    : " + voltage + (String)"V\n" +
            (String)"Arus       : " + current + (String)"A\n" +
            (String)"Daya       : " + power + (String)"W\n" +
            (String)"Energi     : " + energy + (String)"KWh\n" +
            (String)"Frekuensi  : " + frequency + (String)"Hz\n";
            (String)"Faktor daya: " + pf;
      bot.sendMessage(chat_id, reply);
    }

      if (text == "/options")
    {
      String keyboardJson = "[[\"/voltase\", \"/arus\"],[\"/energi\", \"/daya\"],[\"/frekuensi\", \"/pf\"],[\"/-pf\", \"/+pf\"],[\"/kondisi\"]]";
      bot.sendMessageWithReplyKeyboard(chat_id, "pilih salah satu reply untuk perintah", "", keyboardJson, true);
    }

    if (text == "/start")
    {
      String welcome = "Selamat Datang, " + from_name + ".\n";
      welcome += "masukkan pesan dibawah untuk perintah.\n\n";
      welcome += "/kondisi  : untuk mengetahui seluruh kondisi listrik.\n";
      welcome += "/voltase  : untuk mengetahui kondisi voltase saat ini.\n";
      welcome += "/arus     : untuk mengetahui kondisi arus saat ini.\n";
      welcome += "/daya     : untuk mengetahui kondisi daya saat ini.\n";
      welcome += "/energi   : untuk mengetahui kondisi energi saat ini.\n";
      welcome += "/frekuensi: untuk mengetahui kondisi frekuensi saat ini.\n";
      welcome += "/pf       : untuk mengetahui kondisi faktor daya saat ini.\n";
      welcome += "/+pf      : untuk mengaktifkan perbaikan power factor.\n";
      welcome += "/-pf      : untuk mematikan perbaikan power factor.\n";
      welcome += "/options  : untuk menampilkan reply keyboard\n";
      bot.sendMessage(chat_id, welcome);
    }
  }
}

void setup() {
Serial.begin(9600);
Serial2.begin(9600, SERIAL_8N1, RXD2, TXD2);   
lcd.init();
lcd.backlight();              
lcd.setCursor(4,1);
lcd.print("IOT Telegram");
lcd.setCursor(1,2);
lcd.print("Monitoring Listrik");
pinMode (relay, OUTPUT);
pinMode (relay1, OUTPUT);
digitalWrite(relay,LOW);
digitalWrite(relay1,HIGH);
// attempt to connect to Wifi network:
  Serial.print("Connecting to Wifi SSID ");
  Serial.print(WIFI_SSID);
  WiFi.begin(WIFI_SSID, WIFI_PASSWORD);
  secured_client.setCACert(TELEGRAM_CERTIFICATE_ROOT); // Add root certificate for api.telegram.org
  while (WiFi.status() != WL_CONNECTED)
  {
    Serial.print(".");
    delay(500);
  }
  lcd.clear();
}

void loop() {
 // lcd.clear();
    float voltage = pzem.voltage();
    if(!isnan(voltage)){
        Serial.print("Voltage: "); 
        Serial.print(voltage); 
        Serial.println("V");
    } else {
        Serial.println("Error reading voltage");
    }

    float current = pzem.current();
    if(!isnan(current)){
        Serial.print("Current: ");
        Serial.print(current); 
        Serial.println("A");
    } else {
        Serial.println("Error reading current");
    }

    float power = pzem.power();
    if(!isnan(power)){
        Serial.print("Power: "); 
        Serial.print(power); 
        Serial.println("W");
    } else {
        Serial.println("Error reading power");
    }

    float energy = pzem.energy();
    if(!isnan(energy)){
        Serial.print("Energy: ");
        Serial.print(energy,3); 
        Serial.println("kWh");
        
    } else {
        Serial.println("Error reading energy");
    }

    float frequency = pzem.frequency();
    if(!isnan(frequency)){
        Serial.print("Frequency: ");
        Serial.print(frequency, 1); 
        Serial.println("Hz");
    } else {
        Serial.println("Error reading frequency");
    }

    float pf = pzem.pf();
    if(!isnan(pf)){
        Serial.print("PF: "); 
        Serial.println(pf);
    } else {
        Serial.println("Error reading power factor");
    }
    
if (millis() - bot_lasttime > BOT_MTBS)
  {
    int numNewMessages = bot.getUpdates(bot.last_message_received + 1);

    while (numNewMessages)
    {
      Serial.println("got response");
      handleNewMessages(numNewMessages);
      numNewMessages = bot.getUpdates(bot.last_message_received + 1);
    }

    bot_lasttime = millis();
  }
  //---------LCD I2C--------------
   lcd.setCursor(2,0);
   lcd.print("Kondisi Listrik");
   lcd.setCursor(0,1);
   lcd.print("V:");
   lcd.print(voltage);
   lcd.print("V");
   lcd.setCursor(0,2);
   lcd.print("I:");
   lcd.print(current);
   lcd.print("A");  
   lcd.setCursor(0,3);
   lcd.print("W:");
   lcd.print(power);
   lcd.print("W");
   lcd.setCursor(10,1);
   lcd.print("F:");
   lcd.print(frequency);
   lcd.print("Hz");
   lcd.setCursor(10,2);
   lcd.print("PF:");
   lcd.print(pf);
   lcd.setCursor(10,3);
   lcd.print("E:");
   lcd.print(energy);
   lcd.print("KWh");

   if(current>1){
    digitalWrite(relay,HIGH);
   }
   else{
    digitalWrite(relay,LOW);
   }
Serial.println();
delay(500);
}
